if($Pref::Server::DGBOXSIZEPOS $= "")
	$Pref::Server::DGBOXSIZEPOS = "40 40 40 0 0 40";

datablock staticShapeData(DGBOXFLOORData)
{
	shapeFile = "Add-Ons/Server_Box/FLOOR.dts";
};
datablock staticShapeData(DGBOXCEILData)
{
	shapeFile = "Add-Ons/Server_Box/CEIL.dts";
};
datablock staticShapeData(DGBOXWALLNData)
{
	shapeFile = "Add-Ons/Server_Box/WALLN.dts";
};
datablock staticShapeData(DGBOXWALLEData)
{
	shapeFile = "Add-Ons/Server_Box/WALLE.dts";
};
datablock staticShapeData(DGBOXWALLSData)
{
	shapeFile = "Add-Ons/Server_Box/WALLS.dts";
};
datablock staticShapeData(DGBOXWALLWData)
{
	shapeFile = "Add-Ons/Server_Box/WALLW.dts";
};
datablock TriggerData(DGBOXTrigger)
{
		tickPeriodMS = 500;
};

function DGBOXTrigger::onLeaveTrigger(%this, %trigger, %obj)
{
	Parent::onLeaveTrigger(%this, %trigger, %obj);
	%classname = %obj.getClassName();
	switch$ (%classname)
	{
		case "Player":
			if(!%obj.client.DGBOXNOKILL)
				%obj.schedule(1,"kill");
		case "WheeledVehicle":
			if(isObject(%obj.spawnBrick))
			{
				%obj.spawnBrick.spawnVehicleSchedule = %obj.spawnBrick.schedule(1, "respawnVehicle");
			}
			else
			{
				%obj.schedule(1,"delete");
			}
		case "FlyingVehicle":
			if(isObject(%obj.spawnBrick))
			{
				%obj.spawnBrick.spawnVehicleSchedule = %obj.spawnBrick.schedule(1, "respawnVehicle");
			}
			else
			{
				%obj.schedule(1,"delete");
			}
		case "AIPlayer":
			%obj.schedule(1,"kill");
	}
}

function servercmdboxfindrange(%client)
{
	if(%client.isAdmin)
	{
		%mbg = mainBrickGroup;
		%mbgcount = mainBrickGroup.getCount();
		for(%a=0;%a<%mbgcount;%a++)
		{
			%bg = %mbg.getObject(%a);
			%bgcount = %bg.getCount();
			for(%b=0;%b<%bgcount;%b++)
			{
				%wbox = %bg.getObject(%b).getWorldBox();
				if(%xLow $= ""){%xLow = getWord(%wbox,0);%yLow = getWord(%wbox,1);%zLow = getWord(%wbox,2);%xHigh = getWord(%wbox,3);%yHigh = getWord(%wbox,4);%zHigh = getWord(%wbox,5);}
				if(getWord(%wbox,0)<%xLow)
					%xLow = getWord(%wbox,0);
				if(getWord(%wbox,1)<%yLow)
					%yLow = getWord(%wbox,1);
				if(getWord(%wbox,2)<%zLow)
					%zLow = getWord(%wbox,2);
				if(getWord(%wbox,3)>%xHigh)
					%xHigh = getWord(%wbox,3);
				if(getWord(%wbox,4)>%yHigh)
					%yHigh = getWord(%wbox,4);
				if(getWord(%wbox,5)>%zHigh)
					%zHigh = getWord(%wbox,5);
			}
		}
		%posx = (%xLow+%xHigh)/2;
		%posy = (%yLow+%yHigh)/2;
		%posz = (%zLow+%zHigh)/2;
		%sizex = mAbs(%xLow-%xHigh)/2;
		%sizey = mAbs(%yLow-%yHigh)/2;
		%sizez = mAbs(%zLow-%zHigh)/2;


		messageClient(%client,0,"\c6Suggested size is \c3"@%sizex SPC %sizey SPC %sizez@"\c6 with a position of \c3"@%posx SPC %posy SPC %posz);
	}
}

function servercmdboxnokill(%client)
{
	if(%client.isAdmin)
	{
		if(%client.DGBOXNOKILL)
		{
			%client.DGBOXNOKILL = "";
			messageclient(%client,0,"\c6You will now die outside of the box.");
		}
		else
		{
			%client.DGBOXNOKILL = 1;
			messageclient(%client,0,"\c6You will no longer die outside of the box.");
		}
	}
}

function servercmdsetbox(%client, %sizex, %sizey, %sizez, %posx, %posy, %posz)
{
	if(!%client.isAdmin)
	{
		messageclient(%client,0,"\c6Only admins can do that.");
		return;
	}

	if(%sizex $= ""||%sizey $= ""||%sizez $= ""||%posx $= ""||%posy $= ""||%posz $= "")
	{
		messageclient(%client,0,"\c6Usage: /setbox [SIZEX] [SIZEY] [SIZEZ] [POSX] [POSY] [POSZ]");
		messageclient(%client,0,"\c6Size is box radius in 2x cubes.");
		messageclient(%client,0,"\c6Position is the center of the box.");
		return;
	}

	%sizex = mAbs(mCeil(%sizex*2)/2);
	%sizey = mAbs(mCeil(%sizey*2)/2);
	%sizez = mAbs(mCeil(%sizez*5)/5);
	if(%sizex<=0)
		%sizex = 0.25;
	if(%sizey<=0)
		%sizey = 0.25;
	if(%sizez<=0)
		%sizez = 0.1;
	%posx = mCeil(%posx*4)/4;
	%posy = mCeil(%posy*4)/4;
	%posz = mCeil(%posz*10)/10;

	$Pref::Server::DGBOXSIZEPOS = %sizex SPC %sizey SPC %sizez SPC %posx SPC %posy SPC %posz;
	if(DGBOXSO.makebox())
	{
		messageclient(%client,0,"\c6Box set to size \c3"@%sizex SPC %sizey SPC %sizez@"\c6 with a position of \c3"@%posx SPC %posy SPC %posz);
	}
	else
	{
		messageclient(%client,0,"\c0Unknown error. Maybe there's something in the host's console?");
	}
}

function DGBOXSO::makebox(%this)
{
	%sizex = getWord($Pref::Server::DGBOXSIZEPOS,0);
	%sizey = getWord($Pref::Server::DGBOXSIZEPOS,1);
	%sizez = getWord($Pref::Server::DGBOXSIZEPOS,2);
	%posx = getWord($Pref::Server::DGBOXSIZEPOS,3);
	%posy = getWord($Pref::Server::DGBOXSIZEPOS,4);
	%posz = getWord($Pref::Server::DGBOXSIZEPOS,5);

	if(isObject(%this.boxgroup))
	{
		%this.boxgroup.floor.setTransform(%posx SPC %posy SPC %posz-%sizez SPC "1 0 0 0");
		%this.boxgroup.floor.setScale(%sizex SPC %sizey SPC 0.5);
		%this.boxgroup.ceil.setTransform(%posx SPC %posy SPC %posz+%sizez SPC "1 0 0 0");
		%this.boxgroup.ceil.setScale(%sizex SPC %sizey SPC 0.5);
		%this.boxgroup.walln.setTransform(%posx SPC %posy+%sizey SPC %posz SPC "1 0 0 0");
		%this.boxgroup.walln.setScale(%sizex SPC 0.5 SPC %sizez);
		%this.boxgroup.walle.setTransform(%posx+%sizex SPC %posy SPC %posz SPC "1 0 0 0");
		%this.boxgroup.walle.setScale(0.5 SPC %sizey SPC %sizez);
		%this.boxgroup.walls.setTransform(%posx SPC %posy-%sizey SPC %posz SPC "1 0 0 0");
		%this.boxgroup.walls.setScale(%sizex SPC 0.5 SPC %sizez);
		%this.boxgroup.wallw.setTransform(%posx-%sizex SPC %posy SPC %posz SPC "1 0 0 0");
		%this.boxgroup.wallw.setScale(0.5 SPC %sizey SPC %sizez);
		%this.boxgroup.trigger.setTransform(%posx-%sizex SPC %posy+%sizey SPC %posz-%sizez);
		%this.boxgroup.trigger.setScale(vectorScale(%sizex SPC %sizey SPC %sizez, 2));
	}
	else
	{
		%this.boxgroup = new SimGroup();
		MissionCleanup.add(%this.boxgroup);

		%this.boxgroup.floor = new StaticShape()
		{
			position = %posx SPC %posy SPC %posz-%sizez;
			rotation = "1 0 0 0";
			scale = %sizex SPC %sizey SPC 0.5;
			dataBlock = "DGBOXFLOORData";
			cansetIFLS = "0";
		};
		%this.boxgroup.add(%this.boxgroup.floor);
		%this.boxgroup.ceil = new StaticShape()
		{
			position = %posx SPC %posy SPC %posz+%sizez;
			rotation = "1 0 0 0";
			scale = %sizex SPC %sizey SPC 0.5;
			dataBlock = "DGBOXCEILData";
			cansetIFLS = "0";
		};
		%this.boxgroup.add(%this.boxgroup.ceil);
		%this.boxgroup.walln = new StaticShape()
		{
			position = %posx SPC %posy+%sizey SPC %posz;
			rotation = "1 0 0 0";
			scale = %sizex SPC 0.5 SPC %sizez;
			dataBlock = "DGBOXWALLNData";
			cansetIFLS = "0";
		};
		%this.boxgroup.add(%this.boxgroup.walln);
		%this.boxgroup.walle = new StaticShape()
		{
			position = %posx+%sizex SPC %posy SPC %posz;
			rotation = "1 0 0 0";
			scale = 0.5 SPC %sizey SPC %sizez;
			dataBlock = "DGBOXWALLEData";
			cansetIFLS = "0";
		};
		%this.boxgroup.add(%this.boxgroup.walle);
		%this.boxgroup.walls = new StaticShape()
		{
			position = %posx SPC %posy-%sizey SPC %posz;
			rotation = "1 0 0 0";
			scale = %sizex SPC 0.5 SPC %sizez;
			dataBlock = "DGBOXWALLSData";
			cansetIFLS = "0";
		};
		%this.boxgroup.add(%this.boxgroup.walls);
		%this.boxgroup.wallw = new StaticShape()
		{
			position = %posx-%sizex SPC %posy SPC %posz;
			rotation = "1 0 0 0";
			scale = 0.5 SPC %sizey SPC %sizez;
			dataBlock = "DGBOXWALLWData";
			cansetIFLS = "0";
		};
		%this.boxgroup.add(%this.boxgroup.wallw);
		%this.boxgroup.trigger = new Trigger()
		{
			position = %posx-%sizex SPC %posy+%sizey SPC %posz-%sizez;
			rotation = "1 0 0 0";
			scale = vectorScale(%sizex SPC %sizey SPC %sizez, 2);
			dataBlock = "DGBOXTrigger";
			polyhedron = "0.0000000 0.0000000 0.0000000 1.0000000 0.0000000 0.0000000 0.0000000 -1.0000000 0.0000000 0.0000000 0.0000000 1.0000000";
		};
		%this.boxgroup.add(%this.boxgroup.trigger);
	}
	%this.adjustSpawnSphere();
	return 1;
}

function DGBOXSO::adjustSpawnSphere(%this)
{
	if($Pref::Server::DGBOXNOSPAWNADJ==1)
		return;
	
	%sizex = getWord($Pref::Server::DGBOXSIZEPOS,0);
	%sizey = getWord($Pref::Server::DGBOXSIZEPOS,1);
	%sizez = getWord($Pref::Server::DGBOXSIZEPOS,2);
	%posx = getWord($Pref::Server::DGBOXSIZEPOS,3);
	%posy = getWord($Pref::Server::DGBOXSIZEPOS,4);
	%posz = getWord($Pref::Server::DGBOXSIZEPOS,5);

	if(!isObject(PlayerDropPoints))
		return;

	if(isObject(PlayerDropPoints.getObject(0)))
	{
		%spawnsphere = PlayerDropPoints.getObject(0);
		%spawnsphere.setTransform(%posx SPC %posy SPC %posz-%sizez+0.1@" 1 0 0 0");
		%radius = %sizex;
		if(%sizey>%radius)
			%radius = %sizey;
		if(%sizez>%radius)
			%radius = %sizez;
		%spawnsphere.radius = %radius;
	}
}

if(isPackage(DGBOXPACKAGE))
	deactivatepackage(DGBOXPACKAGE);

package DGBOXPACKAGE
{
	function onMissionLoaded()
	{
		if(!isObject(DGBOXSO))
		{
			%so = new ScriptObject("DGBOXSO");
			%so.makebox();
			MissionCleanup.add(%so);
		}
		Parent::onMissionLoaded();
	}
	function fxDTSbrick::Plant(%brick)
	{
		%error = Parent::Plant(%brick);
		if(!%error||%error==2)
		{
			%client = getbrickgroupfromobject(%brick).client;
			%worldbox = %brick.getWorldBox();
			%xLow = getWord(%worldbox, 0);
			%yLow = getWord(%worldbox, 1);
			%zLow = getWord(%worldbox, 2);
			%xHigh = getWord(%worldbox, 3);
			%yHigh = getWord(%worldbox, 4);
			%zHigh = getWord(%worldbox, 5);

			%sizex = getWord($Pref::Server::DGBOXSIZEPOS,0);
			%sizey = getWord($Pref::Server::DGBOXSIZEPOS,1);
			%sizez = getWord($Pref::Server::DGBOXSIZEPOS,2);
			%posx = getWord($Pref::Server::DGBOXSIZEPOS,3);
			%posy = getWord($Pref::Server::DGBOXSIZEPOS,4);
			%posz = getWord($Pref::Server::DGBOXSIZEPOS,5);

			//talk(%xLow SPC %posx-%sizex @"|"@ %yLow SPC %posy-%sizey @"|"@ %zLow SPC %posz-%sizez @"|"@ %xHigh SPC %posx+%sizex @"|"@ %yHigh SPC %posy+%sizey @"|"@ %zHigh SPC %posz+%sizez);

			if(%xLow < %posx-%sizex || %yLow < %posy-%sizey || %zLow < %posz-%sizez || %xHigh > %posx+%sizex || %yHigh > %posy+%sizey || %zHigh > %posz+%sizez)
			{
				if(isObject(%client))
				{
					messageClient(%client, 'MsgPlantError_TooFar');
				}
				return 7;
			}
		}
		return %error;
	}
};
activatepackage(DGBOXPACKAGE);